  //================================================================//
// Programa......: Obtendo informaes da Barra de Tarefas II
// Programador...: Marcos Antonio Gambeta
// Contato.......: dicasdeprogramacao@yahoo.com.br
// Website.......: http://dicasprog.codigolivre.org.br
//================================================================//
// Linguagem.....: Harbour/xHarbour
// Bibliotecas...: Minigui
// Plataforma....: Windows
//================================================================//

#include "minigui.ch"

Function Main

   DEFINE WINDOW Form1 ;
      AT 0,0 ;
      WIDTH 300 ;
      HEIGHT 200 ;
      TITLE "Obtendo informaes da Barra de Tarefas" ;
      MAIN

      @ 30,10 BUTTON Button1 CAPTION "Obter posio da Barra de Tarefas" ;
         WIDTH 280 ON CLICK ObterPosicaoBarraDeTarefas()

      @ 90,10 BUTTON Button2 CAPTION "Obter tamanho da Barra de Tarefas" ;
         WIDTH 280 ON CLICK ObterTamanhoBarraDeTarefas()

   END WINDOW

   CENTER WINDOW Form1

   ACTIVATE WINDOW Form1

   Return Nil

Static Function ObterPosicaoBarraDeTarefas

   Local aPos := GetTaskBarPosition()

   MsgInfo(;
      "TOP="+str(aPos[1],4)+Chr(13)+Chr(10)+;
      "LEFT="+str(aPos[2],4)+Chr(13)+Chr(10)+;
      "BOTTOM="+str(aPos[3],4)+Chr(13)+Chr(10)+;
      "RIGHT="+str(aPos[4],4))
   Return Nil

Static Function ObterTamanhoBarraDeTarefas

   Local aPos := GetTaskBarPosition()

   MsgInfo(;
      "WIDTH="+str(aPos[4]-aPos[2],4)+Chr(13)+Chr(10)+;
      "HEIGHT="+str(aPos[3]-aPos[1],4) )
   Return Nil

// Funo em C para obter a posio da Barra de Tarefas

// GetTaskBarPosition
// Retorna um vetor com 4 elementos, na seguinte ordem:
// [1] = TOP : linha inicial (Y)
// [2] = LEFT : coluna inicial {X)
// [3] = BOTTOM : linha final (Y)
// [4] = RIGHT : coluna final {X)

#pragma begindump

#include <shlobj.h>
#include <windows.h>
#include "hbapi.h"

HB_FUNC( GETTASKBARPOSITION )
{
   APPBARDATA pBarData     ;
   pBarData.cbSize = sizeof(pBarData);
   SHAppBarMessage( ABM_GETTASKBARPOS, &pBarData );
   hb_reta( 4 );
   hb_storvnl( pBarData.rc.top, -1, 1 );
   hb_storvnl( pBarData.rc.left, -1, 2 );
   hb_storvnl( pBarData.rc.bottom, -1, 3 );
   hb_storvnl( pBarData.rc.right, -1, 4 );
}

#pragma enddump
